#!/usr/bin/env lua

Usage = [[

synopsis:
  Run a cycle iterator.
usage:
  lua test16.lua <limit>
]]

local M = {}

Data = {2, 5, 3, 4}

local function make_cycle_iter(data)  -- [1]
  -- carry mutable data in closure.
  local pos = 0
  local count = 0
  local sum = 0
  local sumofsquares = 0
  local function iter(data, pos)
    pos = pos + 1
    if pos > #data then
      pos = 1
    end
    int_item = tonumber(data[pos])
    count = count + 1
    sum = sum + int_item
    sumofsquares = sumofsquares + (int_item * int_item)
    return pos, int_item, count, sum, sumofsquares
  end
  return iter, data, pos
end

function M.test(limit)
  limit = limit or 10
  local idx = 0
  for pos, item, count, sum, sumofsquares in make_cycle_iter(Data) do
    print(idx, pos, item, count, sum, sumofsquares)
    idx = idx + 1
    if idx >= limit then
      break
    end
  end
end

function test()
  if #arg ~= 1 then
    print(Usage)
    os.exit()
  end
  arg1 = tonumber(arg[1])
  M.test(arg1)
end

--test()
return M
